import mpi.*;

class bsend_test {
  static public void main(String[] args) {
    /* Note that the buffer sizes must include the BSEND_OVERHEAD;
       these values are probably sizeof(int) too large */

    int len,tasks,me,i,size,rc;
    Status status;

    MPI.Init(args);
    me=MPI.COMM_WORLD.Rank();

    int data100[] = new int[100000];
    int intsize = 4;
    byte buf100[] = new byte[100000*intsize+MPI.BSEND_OVERHEAD];

    if(me==0) {
      //MPI_Buffer_attach(buf2,sizeof(buf2));
      MPI.Buffer_attach(buf100);

      for(i=0;i<100000;i++)  data100[i] = 1;

      //MPI_Bsend(data,100000,MPI_INT,1,1,MPI_COMM_WORLD);
      MPI.COMM_WORLD.Bsend(data100,0,100000,MPI.INT,1,1);

      //MPI_Recv(data,100000,MPI_INT,1,2,MPI_COMM_WORLD,&status);
      MPI.COMM_WORLD.Recv(data100,0,100000,MPI.INT,1,2);
      for(i=0;i<100000;i++)
	if(data100[i] != 2)  
	  System.out.println
	    ("ERROR, incorrect data["+i+"]="+data100[i]+", task 0");
	      
    } else if(me == 1) {
      //MPI_Buffer_attach(buf2,sizeof(buf2));
      MPI.Buffer_attach(buf100);

      for(i=0;i<100000;i++)  data100[i] = 2;

      //MPI_Bsend(data,100000,MPI_INT,0,2,MPI_COMM_WORLD);
      MPI.COMM_WORLD.Bsend(data100,0,100000,MPI.INT,0,2);

      //MPI_Recv(data,100000,MPI_INT,0,1,MPI_COMM_WORLD,&status);
      MPI.COMM_WORLD.Recv(data100,0,100000,MPI.INT,0,1);      
      for(i=0;i<100000;i++)
	if(data100[i] != 1)  
	  System.out.println
	    ("ERROR , incorrect data["+i+"]="+data100[i]+", task 1");


    }
    //MPI_Barrier(MPI_COMM_WORLD);
    MPI.COMM_WORLD.Barrier();
    if(me == 0)  System.out.println("TESTS COMPLETE\n");
    MPI.Finalize();
  }
}


